<template>
  <board-list-header title="My Personal Boards" />
  <div class="board-list">
    <slot />
    <board-add-button @click="handleOpenCreateBoard" />
  </div>
  <board-create-form
    @create="handleCreateBoard"
    :open="openCreateForm"
    @cancel="handleCloseCreateBoard"
    @close="handleCloseCreateBoard"
  />
</template>

<script lang="ts">
import { defineComponent } from "vue";
import BoardListHeader from "../components/BoardListHeader.vue";
import BoardAddButton from "../components/BoardAddButton.vue";
import BoardCreateForm from "./BoardCreateForm.vue";
import { Board } from "@/core/database";

export default defineComponent({
  components: { BoardListHeader, BoardAddButton, BoardCreateForm },
  emits: ["create"],
  data() {
    return {
      openCreateForm: false,
    };
  },
  methods: {
    handleOpenCreateBoard() {
      this.openCreateForm = true;
    },
    handleCloseCreateBoard() {
      this.openCreateForm = false;
    },
    handleCreateBoard(newBoard: Board) {
      this.$emit("create", newBoard);
    },
  },
});
</script>

<style scoped>
.board-list {
  display: grid;
  grid-template-columns: 1fr;
  gap: 1rem;
  margin-top: 1.25rem;
}

@media (min-width: 768px) {
  .board-list {
    grid-template-columns: 1fr 1fr;
  }
}

@media (min-width: 992px) {
  .board-list {
    grid-template-columns: 1fr 1fr 1fr;
  }
}
</style>
